// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from tuw_nav_msgs:msg/BaseConstr.idl
// generated code does not contain a copyright notice
#include "tuw_nav_msgs/msg/detail/base_constr__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
tuw_nav_msgs__msg__BaseConstr__init(tuw_nav_msgs__msg__BaseConstr * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    tuw_nav_msgs__msg__BaseConstr__fini(msg);
    return false;
  }
  // v_max
  // av_max
  // w_max
  // aw_max
  // omg_wh_max
  return true;
}

void
tuw_nav_msgs__msg__BaseConstr__fini(tuw_nav_msgs__msg__BaseConstr * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // v_max
  // av_max
  // w_max
  // aw_max
  // omg_wh_max
}

bool
tuw_nav_msgs__msg__BaseConstr__are_equal(const tuw_nav_msgs__msg__BaseConstr * lhs, const tuw_nav_msgs__msg__BaseConstr * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // v_max
  if (lhs->v_max != rhs->v_max) {
    return false;
  }
  // av_max
  if (lhs->av_max != rhs->av_max) {
    return false;
  }
  // w_max
  if (lhs->w_max != rhs->w_max) {
    return false;
  }
  // aw_max
  if (lhs->aw_max != rhs->aw_max) {
    return false;
  }
  // omg_wh_max
  if (lhs->omg_wh_max != rhs->omg_wh_max) {
    return false;
  }
  return true;
}

bool
tuw_nav_msgs__msg__BaseConstr__copy(
  const tuw_nav_msgs__msg__BaseConstr * input,
  tuw_nav_msgs__msg__BaseConstr * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // v_max
  output->v_max = input->v_max;
  // av_max
  output->av_max = input->av_max;
  // w_max
  output->w_max = input->w_max;
  // aw_max
  output->aw_max = input->aw_max;
  // omg_wh_max
  output->omg_wh_max = input->omg_wh_max;
  return true;
}

tuw_nav_msgs__msg__BaseConstr *
tuw_nav_msgs__msg__BaseConstr__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_nav_msgs__msg__BaseConstr * msg = (tuw_nav_msgs__msg__BaseConstr *)allocator.allocate(sizeof(tuw_nav_msgs__msg__BaseConstr), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(tuw_nav_msgs__msg__BaseConstr));
  bool success = tuw_nav_msgs__msg__BaseConstr__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
tuw_nav_msgs__msg__BaseConstr__destroy(tuw_nav_msgs__msg__BaseConstr * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    tuw_nav_msgs__msg__BaseConstr__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
tuw_nav_msgs__msg__BaseConstr__Sequence__init(tuw_nav_msgs__msg__BaseConstr__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_nav_msgs__msg__BaseConstr * data = NULL;

  if (size) {
    data = (tuw_nav_msgs__msg__BaseConstr *)allocator.zero_allocate(size, sizeof(tuw_nav_msgs__msg__BaseConstr), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = tuw_nav_msgs__msg__BaseConstr__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        tuw_nav_msgs__msg__BaseConstr__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
tuw_nav_msgs__msg__BaseConstr__Sequence__fini(tuw_nav_msgs__msg__BaseConstr__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      tuw_nav_msgs__msg__BaseConstr__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

tuw_nav_msgs__msg__BaseConstr__Sequence *
tuw_nav_msgs__msg__BaseConstr__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  tuw_nav_msgs__msg__BaseConstr__Sequence * array = (tuw_nav_msgs__msg__BaseConstr__Sequence *)allocator.allocate(sizeof(tuw_nav_msgs__msg__BaseConstr__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = tuw_nav_msgs__msg__BaseConstr__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
tuw_nav_msgs__msg__BaseConstr__Sequence__destroy(tuw_nav_msgs__msg__BaseConstr__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    tuw_nav_msgs__msg__BaseConstr__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
tuw_nav_msgs__msg__BaseConstr__Sequence__are_equal(const tuw_nav_msgs__msg__BaseConstr__Sequence * lhs, const tuw_nav_msgs__msg__BaseConstr__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!tuw_nav_msgs__msg__BaseConstr__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
tuw_nav_msgs__msg__BaseConstr__Sequence__copy(
  const tuw_nav_msgs__msg__BaseConstr__Sequence * input,
  tuw_nav_msgs__msg__BaseConstr__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(tuw_nav_msgs__msg__BaseConstr);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    tuw_nav_msgs__msg__BaseConstr * data =
      (tuw_nav_msgs__msg__BaseConstr *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!tuw_nav_msgs__msg__BaseConstr__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          tuw_nav_msgs__msg__BaseConstr__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!tuw_nav_msgs__msg__BaseConstr__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
