// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_nav_msgs:msg/BaseConstr.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__BASE_CONSTR__TRAITS_HPP_
#define TUW_NAV_MSGS__MSG__DETAIL__BASE_CONSTR__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_nav_msgs/msg/detail/base_constr__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace tuw_nav_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const BaseConstr & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: v_max
  {
    out << "v_max: ";
    rosidl_generator_traits::value_to_yaml(msg.v_max, out);
    out << ", ";
  }

  // member: av_max
  {
    out << "av_max: ";
    rosidl_generator_traits::value_to_yaml(msg.av_max, out);
    out << ", ";
  }

  // member: w_max
  {
    out << "w_max: ";
    rosidl_generator_traits::value_to_yaml(msg.w_max, out);
    out << ", ";
  }

  // member: aw_max
  {
    out << "aw_max: ";
    rosidl_generator_traits::value_to_yaml(msg.aw_max, out);
    out << ", ";
  }

  // member: omg_wh_max
  {
    out << "omg_wh_max: ";
    rosidl_generator_traits::value_to_yaml(msg.omg_wh_max, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const BaseConstr & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: v_max
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "v_max: ";
    rosidl_generator_traits::value_to_yaml(msg.v_max, out);
    out << "\n";
  }

  // member: av_max
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "av_max: ";
    rosidl_generator_traits::value_to_yaml(msg.av_max, out);
    out << "\n";
  }

  // member: w_max
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "w_max: ";
    rosidl_generator_traits::value_to_yaml(msg.w_max, out);
    out << "\n";
  }

  // member: aw_max
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "aw_max: ";
    rosidl_generator_traits::value_to_yaml(msg.aw_max, out);
    out << "\n";
  }

  // member: omg_wh_max
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "omg_wh_max: ";
    rosidl_generator_traits::value_to_yaml(msg.omg_wh_max, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const BaseConstr & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_nav_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_nav_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_nav_msgs::msg::BaseConstr & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_nav_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_nav_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_nav_msgs::msg::BaseConstr & msg)
{
  return tuw_nav_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_nav_msgs::msg::BaseConstr>()
{
  return "tuw_nav_msgs::msg::BaseConstr";
}

template<>
inline const char * name<tuw_nav_msgs::msg::BaseConstr>()
{
  return "tuw_nav_msgs/msg/BaseConstr";
}

template<>
struct has_fixed_size<tuw_nav_msgs::msg::BaseConstr>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<tuw_nav_msgs::msg::BaseConstr>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<tuw_nav_msgs::msg::BaseConstr>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_NAV_MSGS__MSG__DETAIL__BASE_CONSTR__TRAITS_HPP_
