// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_nav_msgs:msg/JointsIWS.idl
// generated code does not contain a copyright notice

#ifndef TUW_NAV_MSGS__MSG__DETAIL__JOINTS_IWS__TRAITS_HPP_
#define TUW_NAV_MSGS__MSG__DETAIL__JOINTS_IWS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_nav_msgs/msg/detail/joints_iws__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace tuw_nav_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const JointsIWS & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: type_steering
  {
    out << "type_steering: ";
    rosidl_generator_traits::value_to_yaml(msg.type_steering, out);
    out << ", ";
  }

  // member: type_revolute
  {
    out << "type_revolute: ";
    rosidl_generator_traits::value_to_yaml(msg.type_revolute, out);
    out << ", ";
  }

  // member: steering
  {
    if (msg.steering.size() == 0) {
      out << "steering: []";
    } else {
      out << "steering: [";
      size_t pending_items = msg.steering.size();
      for (auto item : msg.steering) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: revolute
  {
    if (msg.revolute.size() == 0) {
      out << "revolute: []";
    } else {
      out << "revolute: [";
      size_t pending_items = msg.revolute.size();
      for (auto item : msg.revolute) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const JointsIWS & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: type_steering
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type_steering: ";
    rosidl_generator_traits::value_to_yaml(msg.type_steering, out);
    out << "\n";
  }

  // member: type_revolute
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type_revolute: ";
    rosidl_generator_traits::value_to_yaml(msg.type_revolute, out);
    out << "\n";
  }

  // member: steering
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.steering.size() == 0) {
      out << "steering: []\n";
    } else {
      out << "steering:\n";
      for (auto item : msg.steering) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: revolute
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.revolute.size() == 0) {
      out << "revolute: []\n";
    } else {
      out << "revolute:\n";
      for (auto item : msg.revolute) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const JointsIWS & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_nav_msgs

namespace rosidl_generator_traits
{

[[deprecated("use tuw_nav_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const tuw_nav_msgs::msg::JointsIWS & msg,
  std::ostream & out, size_t indentation = 0)
{
  tuw_nav_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use tuw_nav_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const tuw_nav_msgs::msg::JointsIWS & msg)
{
  return tuw_nav_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<tuw_nav_msgs::msg::JointsIWS>()
{
  return "tuw_nav_msgs::msg::JointsIWS";
}

template<>
inline const char * name<tuw_nav_msgs::msg::JointsIWS>()
{
  return "tuw_nav_msgs/msg/JointsIWS";
}

template<>
struct has_fixed_size<tuw_nav_msgs::msg::JointsIWS>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_nav_msgs::msg::JointsIWS>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_nav_msgs::msg::JointsIWS>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_NAV_MSGS__MSG__DETAIL__JOINTS_IWS__TRAITS_HPP_
